/*
 *    Copyright 2014-2023 IHE International
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

/**
 * TLSTest.java
 * <p>
 * File generated from the ATNAQuestionnaire::TLSTest uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.atna.questionnaire.model;

// End of user code

import org.hibernate.annotations.Type;
import org.w3c.dom.Node;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import java.util.ArrayList;
import java.util.List;

/**
 * Description of the class TLSTest.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "TLSTest", propOrder = {"testUrl", "comment", "connectionType", "side", "status"})
@XmlRootElement(name = "TLSTest")
@Entity
@Table(name = "atna_tls_test", schema = "public")
@SequenceGenerator(name = "atna_tls_test_sequence", sequenceName = "atna_tls_test_id_seq", allocationSize = 1)
public class TLSTest implements java.io.Serializable, SystemRegistrationComparable {

    /**
     *
     */
    private static final long serialVersionUID = 1L;

    @Id
    @NotNull
    @Column(name = "id", unique = true, nullable = false)
    @GeneratedValue(generator = "atna_tls_test_sequence", strategy = GenerationType.SEQUENCE)
    private Integer id;
    /**
     * URL of the test in TLS simulator.
     */
    @XmlElement(name = "TestUrl")
    @Column(name = "test_url")
    public String testUrl;

    @XmlElement(name = "Comment")
    @Lob
    @Type(type = "text")
    private String comment;
    /**
     * available tests in TLS Simulators are for HL7v2 (MLLP), DICOM, Syslog and HTTP.
     */
    @XmlAttribute(name = "connectionType", required = true)
    @Column(name = "connection_type")
    private ConnectionType connectionType;
    /**
     * this the SUT acting as Client or Server for this test : client test is requested for outbound connections and server test for inbound connections.
     */
    @XmlAttribute(name = "side", required = true)
    private SideType side;
    /**
     * status of the test in TLS Simulator (extracted thanks to the URL of the test).
     */
    @XmlAttribute(name = "status")
    private ValidationStatus status;

    @ManyToOne(cascade = {CascadeType.MERGE, CascadeType.PERSIST})
    @JoinColumn(name = "atna_questionnaire_id")
    private ATNAQuestionnaireType atnaQuestionnaire;
    /**
     * An attribute containing marshalled element node
     */
    @XmlTransient
    @Transient
    private org.w3c.dom.Node xmlNodePresentation;

    public TLSTest() {
        super();
        status = ValidationStatus.NOTPERFORMED;
    }

    public TLSTest(SideType testedSide, ConnectionType connection) {
        super();
        status = ValidationStatus.NOTPERFORMED;
        side = testedSide;
        connectionType = connection;
    }

    public Integer getId() {
        return id;
    }

    /**
     * Return testUrl.
     *
     * @return testUrl : URL of the test in TLS simulatorURL of the test in TLS simulator
     */
    public String getTestUrl() {
        return testUrl;
    }

    /**
     * Set a value to attribute testUrl.
     *
     * @param testUrl : URL of the test in TLS simulatorURL of the test in TLS simulator.
     */
    public void setTestUrl(String testUrl) {
        if (testUrl != null && !testUrl.trim().isEmpty()) {
            this.testUrl = testUrl.trim();
        } else {
            this.testUrl = null;
        }
    }

    /**
     * Return comment.
     *
     * @return comment
     */
    public String getComment() {
        return comment;
    }

    /**
     * Set a value to attribute comment.
     *
     * @param comment
     *            .
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    /**
     * Return connectionType.
     *
     * @return connectionType : available tests in TLS Simulators are for HL7v2 (MLLP), DICOM, Syslog and HTTPavailable tests in TLS Simulators are for HL7v2 (MLLP), DICOM, Syslog and HTTP
     */
    public ConnectionType getConnectionType() {
        return connectionType;
    }

    /**
     * Set a value to attribute connectionType.
     *
     * @param connectionType
     *            : available tests in TLS Simulators are for HL7v2 (MLLP), DICOM, Syslog and HTTPavailable tests in TLS Simulators are for HL7v2 (MLLP), DICOM, Syslog and HTTP.
     */
    public void setConnectionType(ConnectionType connectionType) {
        this.connectionType = connectionType;
    }

    /**
     * Return side.
     *
     * @return side : this the SUT acting as Client or Server for this test : client test is requested for outbound connections and server test for inbound connectionsthis the SUT acting as Client or
     *         Server for this test : client test is requested for outbound connections and server test for inbound connections
     */
    public SideType getSide() {
        return side;
    }

    /**
     * Set a value to attribute side.
     *
     * @param side
     *            : this the SUT acting as Client or Server for this test : client test is requested for outbound connections and server test for inbound connectionsthis the SUT acting as Client or
     *            Server for this test : client test is requested for outbound connections and server test for inbound connections.
     */
    public void setSide(SideType side) {
        this.side = side;
    }

    /**
     * Return status.
     *
     * @return status : status of the test in TLS Simulator (extracted thanks to the URL of the test)status of the test in TLS Simulator (extracted thanks to the URL of the test)
     */
    public ValidationStatus getStatus() {
        return status;
    }

    /**
     * Set a value to attribute status.
     *
     * @param status
     *            : status of the test in TLS Simulator (extracted thanks to the URL of the test)status of the test in TLS Simulator (extracted thanks to the URL of the test).
     */
    public void setStatus(ValidationStatus status) {
        this.status = status;
    }

    /**
     * Return ATNA Questionnaire
     *
     * @return atnaQuestionnaire
     */
    public ATNAQuestionnaireType getAtnaQuestionnaire() {
        return atnaQuestionnaire;
    }

    /**
     * Set the ATNA Questionnaire
     *
     * @param atnaQuestionnaire : ATNA Questionnaire to link to
     */
    void setAtnaQuestionnaire(ATNAQuestionnaireType atnaQuestionnaire) {
        this.atnaQuestionnaire = atnaQuestionnaire;
    }

    public Node getXmlNodePresentation() {
        if (xmlNodePresentation == null) {
            xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "TLSTest", this);
        }
        return xmlNodePresentation;
    }

    public void setXmlNodePresentation(Node xmlNodePresentation) {
        this.xmlNodePresentation = xmlNodePresentation;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((atnaQuestionnaire == null) ? 0 : atnaQuestionnaire.hashCode());
        result = prime * result + ((connectionType == null) ? 0 : connectionType.hashCode());
        result = prime * result + ((side == null) ? 0 : side.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        TLSTest other = (TLSTest) obj;
        if (atnaQuestionnaire == null) {
            if (other.atnaQuestionnaire != null) {
                return false;
            }
        } else if (!atnaQuestionnaire.equals(other.atnaQuestionnaire)) {
            return false;
        }
        if (connectionType != other.connectionType) {
            return false;
        }
        if (side != other.side) {
            return false;
        }
        return true;
    }

    @Override
    public boolean isEquivalent(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        TLSTest other = (TLSTest) obj;
        if (connectionType != other.connectionType) {
            return false;
        }
        if (side != other.side) {
            return false;
        }
        return true;
    }


    public static List<TLSTest> computeFromNetworkCommunications(List<NetworkCommunication> networkCommunications) {
        List<TLSTest> tlsTests = new ArrayList<>();
        if (networkCommunications != null) {
            for (NetworkCommunication nc : networkCommunications) {
                TLSTest newTlsTest = new TLSTest(SideType.fromInOut(nc.getInOut()), nc.getType());
                if (!tlsTests.contains(newTlsTest)) {
                    tlsTests.add(newTlsTest);
                }
            }
        }
        return tlsTests;
    }
}